

#include <JTC\JTC.h>
#include <iostream.h>

#define LEN 40
 
class Buffer : public JTCMonitor

{
	char thebuffer[LEN];
	int in;
	int out;
	int chars;

public:
	Buffer()
	{
		in = 0;
		out = 0;
		chars = 0;
		for(int i = 0; i < LEN; i++)
			thebuffer[i] = '_';
	}

    void printBuffer() 
	{
		JTCSynchronized sync(*this);
		cout << "|";
		char display[LEN+1];
		for (int i = 0; i < LEN; i++)
			display[i] = '*';
		display[LEN] = 0;
        for (i = 0; i < chars; i++)
			display[(out+i)%LEN] = thebuffer[(out+i)%LEN];
		cout << display << "|\n";
	}

	char get()
	{
		JTCSynchronized sync(*this);
		while (chars == 0) {
			wait();
		}
		chars--; 
		char c = thebuffer[out];
		out = ( out + 1 ) % LEN;
		cout << "Chars=" << chars << " Out=" << out << endl;
		printBuffer();
		notify();
		return c;
	}
 
	void put(char c)
	{
		JTCSynchronized sync(*this);
		while (chars == LEN) {
			wait();
		}
		chars++;
        thebuffer[in] = c;
		in = (in + 1) % LEN;
	    cout << "Chars=" << chars << " In=" << in << endl;
		printBuffer();
		notify();
	}
};

 Buffer b;

class Producer : public JTCThread

{
	int id;
	char c;
public:
	Producer(int i)
	{
		id = i;
		c = 'a' + i;
	}
	virtual void run()
	{
		while(true) {
			sleep(rand() % 1000);
			cout << "Producer " << id << " awakes " << endl;
			b.put(c);
			cout << "Producer " << id << " puts " << c << endl; 
		}
	}
};

class Consumer : public JTCThread

{
	int id;
public:
	Consumer(int i)
	{
		id = i;
	}
	virtual void run()
	{
		while(true) {
			sleep(rand() % 10000);
			cout << "Consumer " << id << " awakes " << endl;
			cout << "Consumer " << id << " gets " << b.get() << endl; 
		}
	}
};

int main(int argc, char* argv[])

{   
	JTCInitialize initialize;
	Producer* p[2];
	Consumer* c[4];
    for (int i = 0; i < 2; i++) {
		p[i] = new Producer(i);
		p[i]->start();
	}
	for (i = 0; i < 4; i++) {
		c[i] = new Consumer(i);
		c[i]->start();
	}
	return 0;	
}